<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />

  <!-- MQTT.js -->
  <script src="https://unpkg.com/mqtt/dist/mqtt.min.js"></script>

  <!-- Materialize -->
  <!-- Compiled and minified CSS -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css" />

  <!-- Materialize -->
  <!-- Compiled and minified JavaScript -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
  <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">

  <!-- Vue.js -->
  <script src="https://unpkg.com/vue/dist/vue.min.js"></script>
</head>

<body>
  <script>



    console.log("started。。。。");

    console.log(mqtt)

    // Connection option
    const options = {
      clean: true, // Retain connection
      connectTimeout: 4000, // Timeout
      // Authtication
      clientId: 'mqttjs_' + Math.random().toString(16).substr(2, 8),
      username: 'fablabgsv@gmail.com',
      password: 'MQTT_TOKEN'
    }

    // Connection string
    // ws: unsecured WebSocket
    // wss: secured WebSocket connection
    // mqtt: unsecured TCP connection
    // mqtts: secured TCP connection
    const connectUrl = 'ws://maqiatto.com:8883'

    var client = mqtt.connect(connectUrl, options);

    client.on('connect', function () {
      console.log("connected。。。。");
      client.publish("fablabgsv@gmail.com/hello", "hello world!111");
      client.subscribe('fablabgsv@gmail.com/checkpoint1', function (err) {
        if (!err) {
          const badge = document.getElementById("connect-badge")
          badge.innerText = "connected"
          badge.classList.remove("orange")
          badge.classList.add("green")
        }
      })
    })

    client.on('reconnect', (error) => {
      console.log('Reconnecting: ', error)
    })

    client.on('error', (error) => {
      console.log('Connection failed: ', error)
    })


    var data = {};
    data.messages = [];

    client.on('message', function (topic, payload) {
      var message = String.fromCharCode.apply(null, payload);
      console.log(message);
      data.messages.push(message);

      // la led devient jaune
      document.getElementById("ckp").src = "assets/led-jaune.png";

      // le message s'affiche
      document.getElementById("txtckp1").innerHTML=`<p>${data.messages}</p>`;

      // le bouton devient activable
      document.getElementById("divbutton").innerHTML+=`<div class="card-content">
            <span class="card-title activator grey-text text-darken-4">Déclencher le bouton<i class="material-icons right">more_vert</i></span>
          </div>
          <div class="card-reveal">
            <span class="card-title grey-text text-darken-4">Déclencher le bouton<i class="material-icons right">close</i></span>
            <p>publication d'un message MQTT à la topic "finish" <a class="btn-floating green" href="#" id="btnpub" onclick="handlePub(); return false;"><i class="material-icons right">send</i></a>.</p>
          </div>`;

    });

    function handlePub() {
      client.publish("fablabgsv@gmail.com/finish", "demo | go to finish it !");
      console.log("mqtt pub to finish ");
    };
  </script>



  <div class="container">
    <!-- Page Content goes here -->
    <div class="row">
      <div class="col s12">
        <h1>LAB MQTT demo</h1>
        <h2>
          Status :
          <span id="connect-badge" class="new badge orange" data-badge-caption="">connecting</span>
        </h2>
      </div>
    </div>
    <div class="row">
      <div class="col s12 m4">
        <div class="card small">
          <div class="card-panel center-align">
            <img src="assets/arduino.png" style="height: auto; width: 100%">
            
            <!-- <a class="btn-floating halfway-fab waves-effect waves-light red"><i class="material-icons">add</i></a> -->
          </div>
        </div>
      </div>
      <div class="col s12 m4">
        <div class="card small">
          <div class="card-panel  center-align">
            <img src="assets/led-rouge.png" style="height: auto; width: 10%" id="ckp">
            
            <!-- <a class="btn-floating halfway-fab waves-effect waves-light red"><i class="material-icons">add</i></a> -->
          </div>
          <div class="card-content" id="txtckp1">
            <p>en attente d'un message sur topic "checkpoint1" ...</p>
          </div>
        </div>
      </div>
      <div class="col s12 m4">
        <div class="card small" id="divbutton">
          <div class="card-panel  center-align">
            <img class="activator" src="assets/bouton.png" style="height: auto; width: 55%">
            <!-- <a class="btn-floating halfway-fab waves-effect waves-light red"><i class="material-icons">add</i></a> -->
          </div>
          
        </div>
      </div>
    </div>
  </div>

  <script>
    new Vue({
      el: '#messages',
      data: data
    });
  </script>
</body>

</html>